#A dependency shotgun - installs a bunch of packages

packages = [
    "2to3",
    "Cython",
    "HTMLParser",
    "IPython",
    "Imath",
    "OpenEXR",
    "PIL",
    "PyYAML",
    "Pyperclip",
    "SentencePiece",
    "accelerate",
    "addict",
    "aiohttp",
    "albumentations",
    "apriltag",
    "art",
    "ascii-magic",
    "asciinema",
    "astor",
    "austin-dist",
    "austin-tui",
    "av",
    "beautifulsoup4",
    "black",
    "blist",
    "bokeh",
    "boto3",
    "bpytop",
    "bs4",
    "click",
    "cloud-detect",
    "cmapy",
    "colorama",
    "cv2",
    "datasets",
    "decord",
    "dill",
    "dploy",
    "drawille",
    "duviz",
    "easydict",
    "editor",
    "einops",
    "embeddify",
    "exofrills",
    "fbchat",
    "ffmpeg-python",
    "filelock",
    "fire",
    "flake8",
    "frogmouth",
    "ftfy",
    "func_timeout",
    "get-mac",
    "getmac",
    "git",
    "glances",
    "googletrans",
    "gpustat",
    "gradio",
    "graphviz",
    "gtts_token",
    "hf_transfer",
    "hiddenlayer",
    "html2text",
    "huggingface",
    "huggingface_hub",
    "icecream",
    "imageio",
    "imageio-ffmpeg",
    "imagesize",
    "imgcat",
    "imgurpython",
    "inflect",
    "ipykernel",
    "ipynbname",
    "ipyplot",
    "ipython",
    "isort",
    "iterfzf",
    "js2py",
    "jtree",
    "jupyter",
    "lazyasd",
    "libtmux",
    "loguru",
    "mac_vendor_lookup",
    "macchiato",
    "matplotlib",
    "mediapy",
    "memray",
    "moms_apriltag",
    "more_itertools",
    "moviepy",
    "nbstripout",
    "nltk",
    "numba",
    "numpngw",
    "nvitop",
    "odule_nam",
    "oldest-supported-numpy",
    "omegaconf",
    "openai",
    "opencv-contrib-python",
    "opencv-python",
    "osascript",
    "pandas",
    "patool",
    "peepdis",
    "pillow",
    "pillow-avif-plugin",
    "pillow-jxl-plugin",
    "pillow_heif",
    "playsound",
    "plotille",
    "psutil",
    "ptpython",
    "pudb",
    "py-spy",
    "py3nvml",
    "pyarrow",
    "pyaudio",
    "pydantic",
    "pydub",
    "pyflann",
    "pyfx",
    "pygame",
    "pygments",
    "pyinstrument",
    "pyjpgclipboard",
    "pylcs",
    "pymatbridge",
    "pynput",
    "pypager",
    "pyqt5",
    "pyqtgraph",
    "pyscreenshot",
    "pyserial",
    "pytesseract",
    "python-editorjs2py",
    "python-minifier",
    "pytube",
    "pytubefix",
    "pytz",
    "pyunpack",
    "pyyaml",
    "qrcode",
    "ranger",
    "ray",
    "removestar",
    "requests",
    "rich",
    "rtmidi",
    "scenedetect",
    "scikit-image",
    "scikit-learn",
    "scikit-video",
    "scipy",
    "scrapy",
    "screeninfo",
    "seaborn",
    "send2trash",
    "sentencepiece",
    "serial",
    "setproctitle",
    "sk-video",
    "skimage",
    "sklearn",
    "skvideo",
    "smart_open",
    "snowy",
    "sounddevice",
    "stackprinter",
    "suplemon",
    "sympy",
    "tabview",
    "taichi",
    "tensorboard",
    "textual",
    "textual-imageview",
    "textual-paint",
    "timestring",
    "timg",
    "tmuxp",
    "tokenizers",
    "toml",
    "tqdm",
    "transliterate",
    "twilio",
    "urllib",
    "urwid",
    "visidata",
    "vispy",
    "voluptuous",
    "wandb",
    "watchdog",
    "webcolors",
    "win_unicode_console",
    "word2number",
    "wordcloud",
    "xdoctest",
    "xonsh",
    "yaml",
    "yapf",
    "ydiff",
    "youtube_dl",
    "zalgo-tex",
    "zalgo-text",
]

torch_packages = [
    "SwissArmyTransformer",
    "bitsandbytes",
    "deepspeed",
    "diffusers",
    "peft",
    "safetensors",
    "timm",
    "tomesd",
    "torch",
    "torchviz",
    "torchao",
    "torchaudio",
    "torchdiffeq",
    "torchsde",
    "torchvision",
    "transformers",
    "xformers",
]


    # 'pyflann',#TODO: This needs to be fixed. It's broken for python3. It needs to be fixed using 2to3, and then inlined into this rp package. This is needed for flann_dict

def install(*extra_packages):
    """ 
    Attempts to install as many packages as possible. Skips ones that error. 
    You can add additional packages, such as torch ones with shotgun.install(shotgun.torch_packages)
    """
    import rp

    for package in packages + rp.list_flatten(rp.enlist(x) for x in extra_packages):
        bar='――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――'
        print(bar)
        print("ATTEMPTING TO INSTALL PACKAGE:".center(len(bar)))
        print(package.center(len(bar)))
        print(bar)
        rp.pip_install(package)

if __name__=='__main__':
    try:
        install()
    except:
        print("Shotgun errored and is now cancelled. Try it again with shotgun.shotgun()")
        pass
